﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

	' 0.94 Chris Meier, added
	'	TC.Add(Word As String, Count As Int)
	'	TC.AddAll(Words As List,Counts As List)
	'	TC.AddAll2(Words As List)				' not necessarily unique
	'	TC.Remove(Word As String)				' removes all occurrences
    '   TC.GetUniqueWordCount, GetWordCount		' unique count, and count of all words (not necessarily unique)
	' 0.95 Chris Meier, rescope to 'TagCloud' on 'ItemFrequency'
	'	extracted ItemFrequency
	'	eliminated unnecessary data
	'	added ReplaceWordFrequency, can now change word clouds as needed in one viewer
	
'Class module
Private Sub Class_Globals
	Private WordFrequency As WordFrequency
	Private TCPnl As Panel
	Private WV As WebView
	Private WeightList As List
	Private WeightMap As Map
	Private WeightColorMap As Map
	Private Results() As String	' string for storage. float to 2 digits is plenty
	Private ColLUT As SLColorLUT
	Private StartFontSize As Int = 20
	Private MaxWordsPerLine As Int = 8
	Private BackgroundColor As Int
	Private MinWeight As Int = 100
	Private MaxWeight As Int = 900
	Private WordColor As Int
	Private ToLog As Boolean
	Private mModule As Object
	Private mEventName As String
	Private FontMap As Map
	Private FSizeRatio As Float = 1
	Private cssStyle As String
	Private CountShow As Boolean
	Private CntFountSize As Int = 14
	Private minWordCount As Int = 1
End Sub

'Initializes the object.
'Requires a panel on which to put the tagcloud and an event name For callback when an item is selected.
'Will return a callback to {EventName}_SelectedItem(Item As String) if it exists in the calling module.
Public Sub Initialize(mPnl As Panel,Module As Object,EventName As String, wfWords As WordFrequency)
	mModule = Module
	mEventName = EventName
	TCPnl = mPnl
	WordFrequency = wfWords
	FontMap.Initialize
	WeightColorMap.Initialize

	CreateDefaultFont

	ColLUT.Initialize
	BackgroundColor  = ColLUT.GetColorInt("Sky Blue")
	WordColor = ColLUT.GetColorInt("Navy")
	CreateDefaultWeightColorMap
	
	WV.Initialize("WV")
	TCPnl.AddView(WV,0,0,-2,-2)
	TCPnl.Color = BackgroundColor
	WV.Color = BackgroundColor
End Sub
Private Sub CreateDefaultFont

	FontMap.Put("100","lato-hairline.ttf")
	FontMap.Put("200","lato-light.ttf")
	FontMap.Put("300","lato-light.ttf")
	FontMap.Put("400","lato-regular.ttf")
	FontMap.Put("500","lato-regular.ttf")
	FontMap.Put("600","lato-regular.ttf")
	FontMap.Put("700","lato-bold.ttf")
	FontMap.Put("800","lato-bold.ttf")
	FontMap.Put("900","lato-black.ttf")
End Sub
Private Sub CreateDefaultWeightColorMap
	For i = 1 To 9
		WeightColorMap.Put(i*100,WordColor)
	Next
End Sub
'Draw the tagCloud
Sub Draw

	WV.ZoomEnabled = False
		
	Dim iWordCount As Int = Results.Length
	Dim MaxLineLength As Int = TCPnl.Width/100*80
	
	' Add more words per line as the wordcount increases
	Dim WordsPerLine As Int =Ceil(Sqrt(iWordCount))
	Dim FileLoc As String = File.DirAssets
	
	If WordsPerLine > MaxWordsPerLine Then WordsPerLine= MaxWordsPerLine
	Dim HTML As String = "<!doctype html>" & CRLF
	HTML = HTML & "<head>" & CRLF
	HTML = HTML & "<style>" & CRLF
	HTML = HTML & "@font-face {font-family: tagCloud; src: url('"&FontMap.get("100")&"'); font-weight:100;}" & CRLF
	HTML = HTML & "@font-face {font-family: tagCloud; src: url('"&FontMap.get("200")&"'); font-weight:200;}" & CRLF
	HTML = HTML & "@font-face {font-family: tagCloud; src: url('"&FontMap.get("300")&"'); font-weight:300;}" & CRLF
	HTML = HTML & "@font-face {font-family: tagCloud; src: url('"&FontMap.get("400")&"'); font-weight:400;}" & CRLF
	HTML = HTML & "@font-face {font-family: tagCloud; src: url('"&FontMap.get("500")&"'); font-weight:500;}" & CRLF
	HTML = HTML & "@font-face {font-family: tagCloud; src: url('"&FontMap.get("600")&"'); font-weight:600;}" & CRLF
	HTML = HTML & "@font-face {font-family: tagCloud; src: url('"&FontMap.get("700")&"'); font-weight:700;}" & CRLF
	HTML = HTML & "@font-face {font-family: tagCloud; src: url('"&FontMap.get("800")&"'); font-weight:800;}" & CRLF
	HTML = HTML & "@font-face {font-family: tagCloud; src: url('"&FontMap.get("900")&"'); font-weight:900;}" & CRLF
	
	HTML = HTML & "#content {text-align:center; font-size:"&StartFontSize&"px;}" & CRLF
	HTML = HTML & "#span {font-family: tagCloud,Arial;"
	If cssStyle <> "" Then
	HTML = HTML & cssStyle
	End If

	HTML = HTML & "}" & CRLF
	HTML = HTML & "#count {font-size:"&CntFountSize&"px;}" & CRLF
	HTML = HTML & "a:link {text-decoration:none};a:visited {text-decoration:none;}" & CRLF
	HTML = HTML & "</style>" & CRLF
	HTML = HTML & "</head>" &CRLF
	HTML = HTML & "<body>" &CRLF
	HTML = HTML & "<div id = ""content"">" & CRLF
	'Build Lines
	'Start on 0, and use (i+1) with MOD so MOD works correctly
	Dim i As Int = 0
	
	Do While i < iWordCount
		If WordFrequency.GetCount(i) >= minWordCount Then
			Dim sFontSize As String = Round2((100+(Results(i))*FSizeRatio),1)
			HTML = HTML & "<span id = ""span"" style = font-size:"&sFontSize&"%;"
			HTML = HTML & "font-weight:"&WeightMap.get(Results(i))&";>"
			HTML = HTML & "<a id=""word"" style = color:"&ColLUT.GetRGBHex(WeightColorMap.get(WeightMap.get(Results(i))))
			HTML = HTML & "; href="""&(i)&""">"&WordFrequency.GetWord(i)&" </a>"
			HTML = HTML & "</span>"
			If CountShow Then
				HTML=HTML & "<span id = ""count"">("&NumberFormat(WordFrequency.GetCount(i),1,0)&")</span>"
			End If
			HTML = HTML & CRLF
			If (i+1) Mod WordsPerLine = 0 Then 
				 HTML = HTML & "</br>" & CRLF 
			End If
		End If
		i=i+1
	Loop
	'Log((i-1)&" "&((i-1) Mod WordsPerLine))
	If WordsPerLine>0 Then     ' allow for empty cloud
		If (i) Mod WordsPerLine <> 0 Then HTML=HTML &  "<br>" & CRLF 
	End If
	HTML = HTML & "</div>"&CRLF
	HTML = HTML & "</body>"
	Dim JO As JavaObject = WV
	JO.RunMethod("loadDataWithBaseURL",Array As Object("file:///android_asset/",HTML,"text/html","utf-8",Null))

	If ToLog Then Log(HTML)
End Sub

'Don't display words with a count of less than count.
'Set before calling Create
Sub setMinimumWordCount(Count As Int)
	minWordCount = Count
End Sub
'Set the minimum start font size, Default is 20
Sub setMinFontSize(MinSize As Int)
	StartFontSize = MinSize
End Sub
'Set the minimum weight to use  from range: 100,200,300,400,500,600,700,800,900
'Set before calling Create
Sub setMinimumWeight(Weight As Int)
	MinWeight = Weight
End Sub
'Set the maximum weight to use  from range: 100,200,300,400,500,600,700,800,900
'Set before calling Create
Sub setMaximumWeight(Weight As Int)
	MaxWeight = Weight
End Sub
'Get or Set additional css styling for the words
Sub setStyle(Style As String)
	cssStyle = Style
End Sub
Sub getStyle As String
	Return cssStyle
End Sub
'If the data set has a small range, you can increase the relative difference in font sizes
Sub setFontSizeRatio(Ratio As Float)
	FSizeRatio = Ratio
End Sub
'Set the Maximum number of words to appear on one line
Sub setMaxWords(NoWords As Int)
	MaxWordsPerLine = NoWords
End Sub
'Set the background color for the TagCloud
Sub setColor(Color As Int)
	BackgroundColor=Color
	TCPnl.Color = BackgroundColor
	WV.Color=Color
End Sub
'Set a single wordcolor. If you also specify weight colors after setting this, it will be ignored.
Sub setWordColor(Color As Int)
	WordColor = Color
	For i = 1 To 9
		WeightColorMap.Put(i*100,WordColor)
	Next
End Sub
'Set the top position of the view in the provided panel
Sub setTop(Top As Int)
	WV.Top = Top
End Sub
' Get or Set the WebView background to one of ColorDrawable OR GradientDrawable
' Will return false setting an Object that is not one of the above
Sub setBackground(Background As Object) As Boolean
	If Not(Background Is ColorDrawable OR Background Is GradientDrawable) Then
		Return False
	End If
	WV.Background = Background
	Return True
End Sub
Sub getBackground As Object
	Return WV.Background
End Sub
'Sets the background drawable for the TagCloud
Sub setBackgroundImage(Image As Bitmap)
	WV.setBackgroundImage(Image)
End Sub
' Send generated HTML to the Log
Sub setLog(TL As Boolean)
	ToLog = TL
End Sub
'Set colors for each of the 9 available weights.  Returns true if successful
'If you specify a single word color after setting this, weight colors will be ignored.
'If you do not specify enough colors then False will be returned, if you specify 
'too many it will be logged and the surplus ignored.
Sub setWeightColors(Color() As Int) As Boolean
	If Color.Length < 9 Then
		Log("TagCloud: Not enough colors specified, need 9")
		Return False
	End If
	For i = 1 To Color.Length
		If i > 9 Then Exit
		WeightColorMap.Put((i*100),Color(i-1))
	Next
	If i > 10 Then
		Log("TagCloud: Too many colors specified only need 9, extras have been ignored")
	End If
	Return True
End Sub
'Show or hide the word count.  Hidden by default
'Default font size is 14, you can change this with setShowCountFontSize
Sub setShowCount(Show As Boolean)
	CountShow = Show
End Sub
'If Showcount is requested, you can set a font size.  Default is 14px
Sub setShowCountFontSize(px As Int)
	CntFountSize = px
End Sub
'Clear the current fonts in use
'If you clear the fonts and don't specify new user fonts with AddFont then the default browser font will be used.
Sub ClearFont
	FontMap.Clear
End Sub
'Add/Replace a user font, the files should be added to the Files TAB in the IDE
'It is possible to specify fonts with weights of: 100, 200, 300, 400 (Normal), 500, 600, 700 (Bold), 800, 900
'If you clear the fonts then the default browser font is used for weights that you don't specify, it is better to double up if you
'don't have a font for all weights. you can also specify a minimum and maximum weight to use via the
'MinimumWeight and MaximumWeight methods.  If you don't clear the fonts then the lato font will be used for any you don't specify.
'TagCloud.AddFont(100,"mythinfont")
Sub AddFont(Weight As String,FontFile As String)
	FontMap.Put(Weight,FontFile)
End Sub

'Create the TagCloud
Sub Create
	' Left this out of ItemFrequency, to avoid the 'W' calculation on each 'Add'
	' and avoid multiple manipulations of the % value to get to a 2 decimal result on W
	Dim Results(WordFrequency.getUniqueWordCount) As String
	Dim iTotalWordCount = WordFrequency.GetWordCount
	For i = 0 To Results.Length-1
		Dim W As String = Round2((100*WordFrequency.GetCount(i))/iTotalWordCount,2)
		Results(i) = W
		'Log(Results(i,1))
	Next
	
	WeightMap.Initialize
	
	Log("RL "&Results.Length)
	'Work out the distribution and assign weights
	'Key = Weighting Value = count of Words with that rating
	For i = 0 To Results.Length-1
		WeightMap.Put(Results(i),WeightMap.GetDefault(Results(i),0)+1)
	Next
	
	Dim WeightListSort As List
	WeightListSort.Initialize
	Dim DVal As Double
	WeightList.Initialize
	For Each Val As String In WeightMap.Keys
		WeightList.Add(Val)
		DVal = Val
		WeightListSort.Add(DVal)
	Next
	
	'Map values to match font map weight range
	'Key = Weighting as double, value = appropriate font weight (100 - 900)
	WeightListSort.Sort(True)
	WeightMap.Clear
	Dim Key As String
	Dim Value As Int
	Dim WLMin As Double = 200	' arbitrary
	Dim WLMax As Double = 200
	If WeightListSort.Size>0 Then	' allow for empty cloud
		WLMin = WeightListSort.get(0)
		WLMax = WeightListSort.get(WeightList.Size-1)
	End If
	'If there is no variation is spread, then ensure that weights are in the middle
	If WLMin = WLMax Then
		WLMin = WLMin - 50
		WLMax = WLMax + 50
	End If
	For i = 0 To WeightList.Size-1
		Key = WeightList.get(i)
		'Log(Key)
		Dim K As Double = Key
		Value = ((K - WLMin)/(WLMax - WLMin)) * (MaxWeight - MinWeight) + MinWeight
		'Convert to 100's to suit the required font weight range
		Value = Ceil(Value/100)*100
		WeightMap.Put(Key,Value)
	Next
	
End Sub
'Returns the WebView Object that is used to display the TagCloud
Sub getTCView As WebView
	Return WV
End Sub
Private Sub WV_OverrideURL (URL As String) As Boolean
	Dim Choice As Int = URL.SubString(22)
	If SubExists(mModule,mEventName&"_SelectedItem") Then
		CallSub2(mModule,mEventName&"_SelectedItem",WordFrequency.GetWord(Choice))
	End If
	Return True
	
End Sub
Private Sub WV_PageFinished (URL As String)
	
End Sub
'Get or Set the TagCloud's Visibility
Sub getVisible As Boolean
	Return TCPnl.Visible
End Sub
Sub setVisible(V As Boolean)
	TCPnl.Visible=V
End Sub

Sub ReplaceWordFrequency(wfWords As WordFrequency)
	WordFrequency = wfWords
End Sub