﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
	' 0.95 Chris Meier, extracted WordFrequency
'Class module
Sub Class_Globals
	Private WordList As List   ' unique words
	Private WordCount As List  ' maintained with WordList; counts per unique word
	Private WordsCount As Int  ' maintained with WordList,WordCount; total counts of all words
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	WordList.Initialize
	WordCount.Initialize
    WordsCount = 0
End Sub

Sub Remove(Word As String) As Boolean
	Dim i As Int = WordList.IndexOf(Word)
	If i>=0 Then
		WordsCount = WordsCount - WordCount.Get(i)
		WordList.RemoveAt(i)
		WordCount.RemoveAt(i)
	End If
	Return (i>=0)
End Sub

Sub Add(Word As String, Count As Int)
	Dim i As Int = WordList.IndexOf(Word)
	If i>=0 Then
		WordCount.Set(i, Round(Count + WordCount.Get(i)))
	Else
		WordList.Add(Word)
		WordCount.Add(Count)
	End If
	WordsCount = WordsCount + Count
End Sub

Sub AddAll(Words As List,Counts As List)
	If Words.Size = Counts.Size Then
	For i = 0 To Words.Size-1
		Add(Words.Get(i),Counts.Get(i))
	Next
	End If
End Sub

Sub AddAll2(Words As List)
	For Each Word As String In Words
		Add(Word,1)
	Next
End Sub

Sub GetWordCount As Int
	Return WordsCount   'old WordList.Size, changed from (ea added word occurrence)
End Sub
Sub GetUniqueWordCount As Int 'WordList now has 1 entry per unique word, with WordCount counts
	Return WordList.Size
End Sub

Sub GetWord(i As Int) As String
	Return WordList.Get(i)
End Sub

Sub GetCount(i As Int) As String
	Return WordCount.Get(i)
End Sub